/* diodon.vapi generated by valac 0.56.2, do not modify. */

[CCode (gir_namespace = "Diodon", gir_version = "1.0")]
namespace Diodon {
	[CCode (cheader_filename = "diodon.h")]
	public class ClipboardConfiguration : GLib.Object {
		public ClipboardConfiguration ();
		public string? lookup_app_paste_keybinding (string? apppath);
		public bool add_images { get; set; }
		public string[] app_paste_keybindings { get; set; }
		public string filter_pattern { get; set; }
		public bool instant_paste { get; set; }
		public bool keep_clipboard_content { get; set; }
		public int recent_items_size { get; set; }
		public bool synchronize_clipboards { get; set; }
		public bool use_clipboard { get; set; }
		public bool use_primary { get; set; }
	}
	[CCode (cheader_filename = "diodon.h")]
	public class Controller : GLib.Object {
		public delegate void ActionCallback (string[] args);
		public Controller ();
		public void add_command_line_action (string name, string desc, Diodon.Controller.ActionCallback callback);
		public async void add_file_item (Diodon.ClipboardType type, string paths, string? origin);
		public async void add_image_item (Diodon.ClipboardType type, Gdk.Pixbuf pixbuf, string? origin);
		public async void add_item (Diodon.IClipboardItem item);
		public async void add_static_recent_menu_item (Gtk.MenuItem menu_item);
		public async void add_text_item (Diodon.ClipboardType type, string text, string? origin);
		public async void clear ();
		public void execute_paste (Diodon.IClipboardItem item);
		public bool filter_item (Diodon.IClipboardItem item);
		public GLib.HashTable<string,string> get_command_descriptions ();
		public Diodon.ClipboardConfiguration get_configuration ();
		public Diodon.IClipboardItem get_current_item (Diodon.ClipboardType type);
		public async Diodon.IClipboardItem? get_item_by_checksum (string checksum, GLib.Cancellable? cancellable = null);
		public async GLib.List<Diodon.IClipboardItem> get_items_by_search_query (string search_query, Diodon.ClipboardCategory[]? cats = null, Diodon.ClipboardTimerange date_copied = ClipboardTimerange.ALL, GLib.Cancellable? cancellable = null);
		public async GLib.List<Diodon.IClipboardItem> get_recent_items (Diodon.ClipboardCategory[]? cats = null, Diodon.ClipboardTimerange date_copied = ClipboardTimerange.ALL, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public Gtk.Menu get_recent_menu ();
		public async void init ();
		public void quit ();
		public async void rebuild_recent_menu ();
		public async void remove_item (Diodon.IClipboardItem item);
		public async void remove_static_recent_menu_item (Gtk.MenuItem menu_item);
		public async void select_item (Diodon.IClipboardItem item);
		public async void select_item_by_checksum (string checksum);
		public void show_history ();
		public void show_preferences ();
		public Controller.with_configuration (Diodon.ClipboardConfiguration configuration, bool with_zeitgeist = true);
		public signal void on_add_item (Diodon.IClipboardItem item);
		public signal void on_clear ();
		public signal void on_recent_menu_changed (Gtk.Menu recent_menu);
		public signal void on_remove_item (Diodon.IClipboardItem item);
		public signal void on_select_item (Diodon.IClipboardItem item);
	}
	[CCode (cheader_filename = "diodon.h")]
	public class FileClipboardItem : GLib.Object, Diodon.IClipboardItem {
		public FileClipboardItem (Diodon.ClipboardType clipboard_type, string data, string? origin, GLib.DateTime date_copied) throws GLib.FileError;
	}
	[CCode (cheader_filename = "diodon.h")]
	public class ImageClipboardItem : GLib.Object, Diodon.IClipboardItem {
		public ImageClipboardItem ();
		public ImageClipboardItem.with_image (Diodon.ClipboardType clipboard_type, Gdk.Pixbuf pixbuf, string? origin, GLib.DateTime date_copied) throws GLib.Error;
		public ImageClipboardItem.with_payload (Diodon.ClipboardType clipboard_type, GLib.ByteArray payload, string? origin, GLib.DateTime date_copied) throws GLib.Error;
	}
	[CCode (cheader_filename = "diodon.h")]
	public class TextClipboardItem : GLib.Object, Diodon.IClipboardItem {
		public TextClipboardItem (Diodon.ClipboardType clipboard_type, string data, string? origin, GLib.DateTime date_copied);
	}
	[CCode (cheader_filename = "diodon.h")]
	public abstract class Utility : GLib.Object {
		protected Utility ();
		public static string? get_path_of_active_application ();
		public static string get_user_data_dir ();
		public static bool make_directory_with_parents (string directory);
		public static bool perform_key_event (string accelerator, bool press, ulong delay);
	}
	[CCode (cheader_filename = "diodon.h")]
	public class ZeitgeistClipboardStorage : GLib.Object {
		public const string CLIPBOARD_URI;
		public ZeitgeistClipboardStorage ();
		public async void add_item (Diodon.IClipboardItem item, GLib.Cancellable? cancellable = null);
		public async void clear (GLib.Cancellable? cancellable = null);
		public Diodon.IClipboardItem get_current_item (Diodon.ClipboardType type);
		public async Diodon.IClipboardItem? get_item_by_checksum (string checksum, GLib.Cancellable? cancellable = null);
		public async GLib.List<Diodon.IClipboardItem> get_items_by_search_query (string search_query, Diodon.ClipboardCategory[]? cats = null, Diodon.ClipboardTimerange date_copied = ClipboardTimerange.ALL, GLib.Cancellable? cancellable = null);
		public async GLib.List<Diodon.IClipboardItem> get_recent_items (uint32 num_items, Diodon.ClipboardCategory[]? cats = null, Diodon.ClipboardTimerange date_copied = ClipboardTimerange.ALL, GLib.Cancellable? cancellable = null) throws GLib.Error;
		public bool is_privacy_mode_enabled ();
		public async void remove_item (Diodon.IClipboardItem item, GLib.Cancellable? cancellable = null);
		public async void select_item (Diodon.IClipboardItem item, bool use_clipboard, bool use_primary, GLib.Cancellable? cancellable = null);
		public signal void on_items_deleted ();
		public signal void on_items_inserted ();
	}
	[CCode (cheader_filename = "diodon.h")]
	public interface IClipboardItem : GLib.Object {
		public static bool equal_func (Diodon.IClipboardItem* item_a, Diodon.IClipboardItem* item_b);
		public abstract bool equals (Diodon.IClipboardItem* item);
		public abstract Diodon.ClipboardCategory get_category ();
		public abstract string get_checksum ();
		public abstract Diodon.ClipboardType get_clipboard_type ();
		public abstract GLib.DateTime get_date_copied ();
		public abstract GLib.Icon get_icon ();
		public abstract Gtk.Image? get_image ();
		public abstract string get_label ();
		public abstract string get_mime_type ();
		public abstract string? get_origin ();
		public abstract GLib.ByteArray? get_payload () throws GLib.Error;
		public abstract string get_text ();
		public abstract uint hash ();
		public static uint hash_func (Diodon.IClipboardItem* item);
		public abstract void to_clipboard (Gtk.Clipboard clipboard);
	}
	[CCode (cheader_filename = "diodon.h")]
	public enum ClipboardCategory {
		CLIPBOARD,
		TEXT,
		FILES,
		IMAGES;
		public static Diodon.ClipboardCategory[] all ();
		public string to_string ();
		public static Diodon.ClipboardCategory from_string (string type);
	}
	[CCode (cheader_filename = "diodon.h")]
	public enum ClipboardTimerange {
		ALL,
		LAST_24_HOURS,
		LAST_7_DAYS,
		LAST_30_DAYS,
		LAST_YEAR;
		public static Diodon.ClipboardTimerange[] all ();
		public string to_string ();
		public static Diodon.ClipboardTimerange from_string (string type);
	}
	[CCode (cheader_filename = "diodon.h")]
	public enum ClipboardType {
		NONE,
		CLIPBOARD,
		PRIMARY
	}
}
